Imports System.Runtime.InteropServices
Imports System.Windows.Forms

'    ( Tools - Create GUID)  
' ProgID  (      1).
'     ,     1: 
'regasm.exe vk_XmlTextReaderWriter.dll /codebase 


<ComVisible(True), Guid("ACA5E6E0-DA61-4a05-8024-F0002D0E9616"), ProgId("AddIn.vk_OLE")> _
Public Class vk_OLE

    Implements IInitDone
    Implements ILanguageExtender
    Const c_AddinName As String = "vk_OLE"

#Region "IInitDone implementation"
    '/////////////////////////////////////////////////////////////////////////////////
    Public Sub New() '   COM 
        '      (2 )

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Private Sub Init(<MarshalAs(UnmanagedType.IDispatch)> ByVal pConnection As Object) Implements IInitDone.Init
        '      (2 )
        V7Data.V7Object = pConnection
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Private Sub Done() Implements IInitDone.Done
        '      (2 )

        MessageBox.Show("  ")

        obj1C = Nothing
        V7Data.V7Object = Nothing
        GC.Collect()
        GC.WaitForPendingFinalizers()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Private Sub GetInfo(ByRef pInfo() As Object) Implements IInitDone.GetInfo
        pInfo.SetValue("2000", 0)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub RegisterExtensionAs(ByRef bstrExtensionName As String) Implements ILanguageExtender.RegisterExtensionAs
        bstrExtensionName = c_AddinName
    End Sub
#End Region

#Region ""
    Dim obj1C As Object ' 1
    Dim g_flagInit As Boolean ',   obj1C  
    '<MarshalAs(UnmanagedType.IDispatch)> Dim g_var As Object
    Dim g_var As Object

#End Region

#Region ""
    '/////////////////////////////////////////////////////////////////////////////////
    Enum Props
        '    
        LastProp = 0
    End Enum

    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetNProps(ByRef plProps As Integer) Implements ILanguageExtender.GetNProps
        ' 1      
        plProps = Props.LastProp
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub FindProp(ByVal bstrPropName As String, ByRef plPropNum As Integer) Implements ILanguageExtender.FindProp
        ' 1        

        Select Case bstrPropName
        End Select
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetPropName(ByVal lPropNum As Integer, ByVal lPropAlias As Integer, ByRef pbstrPropName As String) Implements ILanguageExtender.GetPropName
        ' 1 ()      . lPropAlias -  

        pbstrPropName = ""
    End Sub



    '/////////////////////////////////////////////////////////////////////////////////
    '    1
    Sub Raise1CException(ByVal s As String)

        Dim ei As ExcepInfo
        ei.wCode = 1004 ' 
        '1000 -  
        '1001 -  
        '1002 -   !
        '1003 -   !!
        '1004 -   !!!
        '1005 -   i
        '1006 -   err
        '1007 -   ""
        '1008 -   ""
        '1009 -   ""

        ei.scode = 1 '   
        ei.bstrDescription = s '
        ei.bstrSource = c_AddinName

        V7Data.ErrorLog.AddError(c_AddinName, ei)

    End Sub


    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetPropVal(ByVal lPropNum As Integer, ByRef pvarPropVal As Object) Implements ILanguageExtender.GetPropVal
        ' 1    

        Try
            pvarPropVal = Nothing
            Select Case lPropNum

            End Select
        Catch ex As Exception '   ()
            Raise1CException(ex.Message)
        End Try
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub SetPropVal(ByVal lPropNum As Integer, ByRef varPropVal As Object) Implements ILanguageExtender.SetPropVal
        ' 1    
        Select Case lPropNum

            '/////////////////////////////////////////////////////////
            '   ""
        End Select
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub IsPropReadable(ByVal lPropNum As Integer, ByRef pboolPropRead As Boolean) Implements ILanguageExtender.IsPropReadable
        ' 1 ,     
        pboolPropRead = True '     
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub IsPropWritable(ByVal lPropNum As Integer, ByRef pboolPropWrite As Boolean) Implements ILanguageExtender.IsPropWritable
        ' 1 ,     
        pboolPropWrite = True '     
    End Sub

#End Region

#Region ""

    '/////////////////////////////////////////////////////////////////////////////////
    Enum Methods
        '   (  )  
        methTest = 0
        methGetValue = 1
        methSetValue = 2
        methClose = 3
        LastMethod = 4
    End Enum


    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetNMethods(ByRef plMethods As Integer) Implements ILanguageExtender.GetNMethods
        plMethods = Methods.LastMethod
    End Sub


    '/////////////////////////////////////////////////////////////////////////////////
    Sub FindMethod(ByVal bstrMethodName As String, ByRef plMethodNum As Integer) Implements ILanguageExtender.FindMethod
        ' 1     (  )   ()   

        plMethodNum = -1
        Select Case bstrMethodName
            Case "Test", ""
                plMethodNum = Methods.methTest
            Case "GetValue", ""
                plMethodNum = Methods.methGetValue
            Case "SetValue", ""
                plMethodNum = Methods.methSetValue
            Case "Close", ""
                plMethodNum = Methods.methClose
        End Select
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetMethodName(ByVal lMethodNum As Integer, ByVal lMethodAlias As Integer, ByRef pbstrMethodName As String) Implements ILanguageExtender.GetMethodName
        ' 1 ()      . lMethodAlias -  .
        pbstrMethodName = ""
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetNParams(ByVal lMethodNum As Integer, ByRef plParams As Integer) Implements ILanguageExtender.GetNParams
        ' 1      (  )

        Select Case lMethodNum
            Case Methods.methTest
                plParams = 0
            Case Methods.methGetValue
                plParams = 0
            Case Methods.methSetValue
                plParams = 1
            Case Methods.methClose
                plParams = 0
        End Select

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub GetParamDefValue(ByVal lMethodNum As Integer, ByVal lParamNum As Integer, ByRef pvarParamDefValue As Object) Implements ILanguageExtender.GetParamDefValue
        ' 1        
        pvarParamDefValue = Nothing '   
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub HasRetVal(ByVal lMethodNum As Integer, ByRef pboolRetValue As Boolean) Implements ILanguageExtender.HasRetVal
        ' 1 ,     (..    )
        pboolRetValue = True  '      (..   ). 
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    Sub CallAsProc(ByVal lMethodNum As Integer, ByRef paParams As System.Array) Implements ILanguageExtender.CallAsProc
        '     .     .
    End Sub


    '/////////////////////////////////////////////////////////////////////////////////
    Sub CallAsFunc(ByVal lMethodNum As Integer, _
     ByRef pvarRetValue As Object, _
     <MarshalAs(UnmanagedType.IDispatch)> ByRef paParams As System.Array) _
    Implements ILanguageExtender.CallAsFunc

        '     .

        Try
            pvarRetValue = 0 '    1
            Select Case lMethodNum '  
                '//////////////////////////////////////////////////////////
            Case Methods.methTest  '      1
                    If g_flagInit = False Then
                        obj1C = V7Data.V7Object.AppDispatch
                        Marshal.Release(Marshal.GetIDispatchForObject(obj1C))
                        g_flagInit = True
                    End If



                    Dim obj0 As Object

                    obj0 = obj1C.CreateObject(".")
                    obj0.()
                    obj0.()
                    System.Windows.Forms.MessageBox.Show(": " + obj0.)


                    obj0 = Nothing
                    GC.Collect()
                    GC.WaitForPendingFinalizers()

                Case Methods.methSetValue
                    '      1   
                    g_var = paParams.GetValue(0)

                Case Methods.methGetValue
                    '      1   

                    pvarRetValue = g_var

                Case Methods.methClose

                    '     ( 1   )

                    'Marshal.Release(Marshal.GetIDispatchForObject(g_var))
                    g_var = Nothing
                    GC.Collect()
                    GC.WaitForPendingFinalizers()

            End Select

        Catch ex As Exception '  ()
            Raise1CException(ex.Message)
        End Try


    End Sub

#End Region
End Class
